Package com.pixelmed.apps

# Class DownloadOrTransmit

java.lang.Object
java.awt.Component
java.awt.Container
java.awt.Window
java.awt.Frame
javax.swing.JFrame
com.pixelmed.display.ApplicationFrame
com.pixelmed.apps.DownloadOrTransmit

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`, `RootPaneContainer`, `WindowConstants`

public class DownloadOrTransmit extends ApplicationFrame

This class is an application for retrieving DICOM studies of patients and downloading or transmitting them.

It is configured by use of a properties file that resides in the user's home directory in `.com.pixelmed.display.DownloadOrTransmit.properties`.

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`DownloadOrTransmit.ConfigureActionListener`
`protected class`
`DownloadOrTransmit.ExportActionListener`
`protected class`
`DownloadOrTransmit.ExportWorker`
`protected class`
`DownloadOrTransmit.FtpSendActionListener`
`protected class`
`DownloadOrTransmit.FtpSendWorker`
`protected class`
`DownloadOrTransmit.ImportActionListener`
`protected class`
`DownloadOrTransmit.ImportWorker`
`protected class`
`DownloadOrTransmit.LogActionListener`
`protected class`
`DownloadOrTransmit.OurMediaImporter`
`protected class`
`DownloadOrTransmit.OurMultipleInstanceTransferStatusHandler`
`protected class`
`DownloadOrTransmit.OurQueryTreeBrowser`
`protected class`
`DownloadOrTransmit.OurReceivedObjectHandler`
`protected class`
`DownloadOrTransmit.OurSourceDatabaseTreeBrowser`
`protected class`
`DownloadOrTransmit.PurgeActionListener`
`protected class`
`DownloadOrTransmit.PurgeWorker`
`protected class`
`DownloadOrTransmit.QueryActionListener`
`protected class`
`DownloadOrTransmit.QueryWorker`
`protected class`
`DownloadOrTransmit.RetrieveActionListener`
`protected class`
`DownloadOrTransmit.RetrieveWorker`
`protected class`
`DownloadOrTransmit.SendActionListener`
`protected class`
`DownloadOrTransmit.SendWorker`
`protected class`
`DownloadOrTransmit.ViewActionListener`
`protected class`
`DownloadOrTransmit.ViewWorker`

## Nested classes/interfaces inherited from class javax.swing.JFrame

`JFrame.AccessibleJFrame`

## Nested classes/interfaces inherited from class java.awt.Frame

`Frame.AccessibleAWTFrame`

## Nested classes/interfaces inherited from class java.awt.Window

`Window.AccessibleAWTWindow, Window.Type`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected JCheckBox`
`addDicomDirectoryCheckBox`
`protected static String`
`addDicomDirectoryLabelText`
`protected static String`
`addDicomDirectoryToolTipText`
`protected static String`
`configureButtonLabel`
`protected static String`
`configureButtonToolTipText`
`protected DatabaseTreeRecord[]`
`currentDatabaseTreeRecordSelections`
`protected QueryInformationModel`
`currentRemoteQueryInformationModel`
`protected String`
`currentRemoteQuerySelectionLevel`
`protected QueryTreeRecord`
`currentRemoteQuerySelectionQueryTreeRecord`
`protected String`
`currentRemoteQuerySelectionRetrieveAE`
`protected Attribute`
`currentRemoteQuerySelectionUniqueKey`
`protected AttributeList`
`currentRemoteQuerySelectionUniqueKeys`
`protected QueryTreeBrowser`
`currentRemoteQueryTreeBrowser`
`protected SafeCursorChanger`
`cursorChanger`
`protected static String`
`exportButtonLabel`
`protected static String`
`exportButtonToolTipText`
`protected String`
`exportDirectoryPath`
`protected static String`
`exportedZipFileName`
`protected static String`
`filePrefixForDicomInstanceFilesOnInterchangeMedia`
`protected static String`
`fileSuffixForDicomInstanceFilesOnInterchangeMedia`
`protected FTPApplicationProperties`
`ftpApplicationProperties`
`protected static String`
`ftpButtonLabel`
`protected static String`
`ftpButtonToolTipText`
`protected FTPRemoteHostInformation`
`ftpRemoteHostInformation`
`protected JCheckBox`
`hierarchicalExportCheckBox`
`protected static String`
`hierarchicalExportLabelText`
`protected static String`
`hierarchicalExportToolTipText`
`protected static String`
`importButtonLabel`
`protected static String`
`importButtonToolTipText`
`protected String`
`importDirectoryPath`
`protected static String`
`localDatabaseName`
`protected static String`
`localDatabaseServerName`
`protected static String`
`logButtonLabel`
`protected static String`
`logButtonToolTipText`
`protected MessageLogger`
`logger`
`protected static int`
`loggerDialogHeightWanted`
`protected static int`
`loggertDialogWidthWanted`
`protected static String`
`loggerTitleMessage`
`protected static String`
`nameForDicomDirectoryOnInterchangeMedia`
`protected NetworkApplicationInformation`
`networkApplicationInformation`
`protected NetworkApplicationProperties`
`networkApplicationProperties`
`protected String`
`ourCalledAETitle`
`protected SafeProgressBarUpdaterThread`
`progressBarUpdater`
`protected static String`
`propertiesFileName`
`protected static String`
`propertyName_CurrentlySelectedFtpTarget`
`protected static String`
`propertyName_DicomCurrentlySelectedQueryTargetAE`
`protected static String`
`propertyName_DicomCurrentlySelectedStorageTargetAE`
`protected static String`
`purgeButtonLabel`
`protected static String`
`purgeButtonToolTipText`
`protected static String`
`queryButtonLabel`
`protected static String`
`queryButtonToolTipText`
`protected JTextField`
`queryFilterPatientIDTextField`
`protected JTextField`
`queryFilterPatientNameTextField`
`protected JTextField`
`queryFilterStudyDateTextField`
`protected static String`
`queryIntroductionLabelText`
`protected static String`
`queryPatientIDLabelText`
`protected static String`
`queryPatientIDToolTipText`
`protected static String`
`queryPatientNameLabelText`
`protected static String`
`queryPatientNameToolTipText`
`protected static String`
`queryStudyDateLabelText`
`protected static String`
`queryStudyDateToolTipText`
`protected JPanel`
`remoteQueryRetrievePanel`
`protected static String`
`retrieveButtonLabel`
`protected static String`
`retrieveButtonToolTipText`
`protected static String`
`rootNameForDicomInstanceFilesOnInterchangeMedia`
`protected File`
`savedImagesFolder`
`protected static String`
`sendButtonLabel`
`protected static String`
`sendButtonToolTipText`
`protected JCheckBox`
`showDetailedLogCheckBox`
`protected static String`
`showDetailedLogLabelText`
`protected DatabaseInformationModel`
`srcDatabase`
`protected JPanel`
`srcDatabasePanel`
`protected StorageSOPClassSCPDispatcher`
`storageSOPClassSCPDispatcher`
`protected static int`
`textFieldLengthForQueryPatientID`
`protected static int`
`textFieldLengthForQueryPatientName`
`protected static int`
`textFieldLengthForQueryStudyDate`
`protected static int`
`validatorFrameHeightWanted`
`protected static int`
`validatorFrameWidthWanted`
`protected static String`
`viewButtonLabel`
`protected static String`
`viewButtonToolTipText`
`protected static int`
`viewerFrameHeightWanted`
`protected static int`
`viewerFrameWidthWanted`
`protected JCheckBox`
`zipExportCheckBox`
`protected static String`
`zipExportLabelText`

### Fields inherited from class com.pixelmed.display.ApplicationFrame

`resourceBundle, resourceBundleName, statusBarManager`

### Fields inherited from class javax.swing.JFrame

`accessibleContext, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Frame

`ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, NORMAL`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

## Constructor Summary

Constructors
Constructor
Description
`DownloadOrTransmit(String title)`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`activateStorageSCP()`
Start DICOM storage listener for populating source database.
`protected void`
`activateTemporaryDatabases()`
Start local database.
`protected static void`
`exportFiles(Vector<String> filesToCopy, File whereToCopyFiles, String actionNoun, SafeProgressBarUpdaterThread progressBarUpdater, MessageLogger logger, boolean detailedLog, boolean addDicomDirectory, boolean hierarchicalExport, String zipFileName)`
`protected Vector`
`getCurrentSourceFilePathSelections()`
`static String`
`getQueryRetrieveAEFromIdentifier(AttributeList identifier, QueryInformationModel queryInformationModel)`
`static String`
`getQueryRetrieveLevel(AttributeList identifier, Attribute uniqueKey)`
`protected static String`
`getSRDescriptionForLog(AttributeList list)`
`protected static void`
`importFileIntoDatabase(DatabaseInformationModel database, String dicomFileName, String fileRefererenceType)`
`static void`
`main(String[] arg)`
The method to invoke the application.
`protected static String`
`makeNewFullyQualifiedHierarchicalInstancePathName(String sourceFileName)`
`protected static String`
`makeNewFullyQualifiedInterchangeMediaInstancePathName(int fileCount)`
`protected void`
`performRetrieve(AttributeList uniqueKeys, String selectionLevel, String retrieveAE)`
`protected void`
`purgeFilesAndDatabaseInformation(DatabaseTreeRecord[] databaseSelections, MessageLogger logger, SafeProgressBarUpdaterThread progressBarUpdater, int done, int maximum)`
`protected void`
`purgeFilesAndDatabaseInformation(DatabaseTreeRecord databaseSelection, MessageLogger logger, SafeProgressBarUpdaterThread progressBarUpdater, int done, int maximum)`
`protected void`
`setCurrentRemoteQueryInformationModel(String remoteAEForQuery)`
`protected void`
`setCurrentRemoteQuerySelection(AttributeList uniqueKeys, Attribute uniqueKey, AttributeList identifier)`

### Methods inherited from class com.pixelmed.display.ApplicationFrame

`createGUI, getApplicationPropertyFileName, getBooleanPropertyOrDefaultAndAddIt, getBooleanPropertyOrDefaultAndAddIt, getBuildDate, getIntegerPropertyOrDefaultAndAddIt, getIntegerPropertyOrDefaultAndAddIt, getProperties, getPropertyInsistently, getPropertyInsistently, getPropertyOrDefaultAndAddIt, getPropertyOrDefaultAndAddIt, getReleaseString, getStatusBar, loadProperties, localizeJOptionPane, makePathToFileInUsersHomeDirectory, setApplicationPropertyFileName, setBackgroundForGUI, setInternationalizedFontsForGUI, setPreferredLookAndFeelForPlatform, storeProperties, takeSnapShot`

### Methods inherited from class javax.swing.JFrame

`addImpl, createRootPane, frameInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setIconImage, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Frame

`addNotify, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, remove, removeNotify, setBackground, setExtendedState, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, processEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, setVisible, toBack, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, list, list, paintComponents, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, hasFocus, imageUpdate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, list, list, list, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setMixingCutoutShape, setName, setPreferredSize, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.awt.MenuContainer

`getFont`

## Field Details

### propertiesFileName

protected static String propertiesFileName

### propertyName_DicomCurrentlySelectedStorageTargetAE

protected static String propertyName_DicomCurrentlySelectedStorageTargetAE

### propertyName_DicomCurrentlySelectedQueryTargetAE

protected static String propertyName_DicomCurrentlySelectedQueryTargetAE

### propertyName_CurrentlySelectedFtpTarget

protected static String propertyName_CurrentlySelectedFtpTarget

### localDatabaseName

protected static String localDatabaseName

### localDatabaseServerName

protected static String localDatabaseServerName

### rootNameForDicomInstanceFilesOnInterchangeMedia

protected static String rootNameForDicomInstanceFilesOnInterchangeMedia

### filePrefixForDicomInstanceFilesOnInterchangeMedia

protected static String filePrefixForDicomInstanceFilesOnInterchangeMedia

### fileSuffixForDicomInstanceFilesOnInterchangeMedia

protected static String fileSuffixForDicomInstanceFilesOnInterchangeMedia

### nameForDicomDirectoryOnInterchangeMedia

protected static String nameForDicomDirectoryOnInterchangeMedia

### exportedZipFileName

protected static String exportedZipFileName

### textFieldLengthForQueryPatientName

protected static int textFieldLengthForQueryPatientName

### textFieldLengthForQueryPatientID

protected static int textFieldLengthForQueryPatientID

### textFieldLengthForQueryStudyDate

protected static int textFieldLengthForQueryStudyDate

### queryIntroductionLabelText

protected static String queryIntroductionLabelText

### queryPatientNameLabelText

protected static String queryPatientNameLabelText

### queryPatientIDLabelText

protected static String queryPatientIDLabelText

### queryStudyDateLabelText

protected static String queryStudyDateLabelText

### configureButtonLabel

protected static String configureButtonLabel

### logButtonLabel

protected static String logButtonLabel

### queryButtonLabel

protected static String queryButtonLabel

### retrieveButtonLabel

protected static String retrieveButtonLabel

### importButtonLabel

protected static String importButtonLabel

### viewButtonLabel

protected static String viewButtonLabel

### exportButtonLabel

protected static String exportButtonLabel

### sendButtonLabel

protected static String sendButtonLabel

### ftpButtonLabel

protected static String ftpButtonLabel

### purgeButtonLabel

protected static String purgeButtonLabel

### configureButtonToolTipText

protected static String configureButtonToolTipText

### logButtonToolTipText

protected static String logButtonToolTipText

### queryButtonToolTipText

protected static String queryButtonToolTipText

### retrieveButtonToolTipText

protected static String retrieveButtonToolTipText

### importButtonToolTipText

protected static String importButtonToolTipText

### viewButtonToolTipText

protected static String viewButtonToolTipText

### exportButtonToolTipText

protected static String exportButtonToolTipText

### sendButtonToolTipText

protected static String sendButtonToolTipText

### ftpButtonToolTipText

protected static String ftpButtonToolTipText

### purgeButtonToolTipText

protected static String purgeButtonToolTipText

### queryPatientNameToolTipText

protected static String queryPatientNameToolTipText

### queryPatientIDToolTipText

protected static String queryPatientIDToolTipText

### queryStudyDateToolTipText

protected static String queryStudyDateToolTipText

### showDetailedLogLabelText

protected static String showDetailedLogLabelText

### zipExportLabelText

protected static String zipExportLabelText

### hierarchicalExportLabelText

protected static String hierarchicalExportLabelText

### addDicomDirectoryLabelText

protected static String addDicomDirectoryLabelText

### hierarchicalExportToolTipText

protected static String hierarchicalExportToolTipText

### addDicomDirectoryToolTipText

protected static String addDicomDirectoryToolTipText

### loggerTitleMessage

protected static String loggerTitleMessage

### viewerFrameWidthWanted

protected static int viewerFrameWidthWanted

### viewerFrameHeightWanted

protected static int viewerFrameHeightWanted

### validatorFrameWidthWanted

protected static int validatorFrameWidthWanted

### validatorFrameHeightWanted

protected static int validatorFrameHeightWanted

### loggertDialogWidthWanted

protected static int loggertDialogWidthWanted

### loggerDialogHeightWanted

protected static int loggerDialogHeightWanted

### srcDatabase

protected DatabaseInformationModel srcDatabase

### srcDatabasePanel

protected JPanel srcDatabasePanel

### remoteQueryRetrievePanel

protected JPanel remoteQueryRetrievePanel

### showDetailedLogCheckBox

protected JCheckBox showDetailedLogCheckBox

### zipExportCheckBox

protected JCheckBox zipExportCheckBox

### hierarchicalExportCheckBox

protected JCheckBox hierarchicalExportCheckBox

### addDicomDirectoryCheckBox

protected JCheckBox addDicomDirectoryCheckBox

### queryFilterPatientNameTextField

protected JTextField queryFilterPatientNameTextField

### queryFilterPatientIDTextField

protected JTextField queryFilterPatientIDTextField

### queryFilterStudyDateTextField

protected JTextField queryFilterStudyDateTextField

### progressBarUpdater

protected SafeProgressBarUpdaterThread progressBarUpdater

### cursorChanger

protected SafeCursorChanger cursorChanger

### logger

protected MessageLogger logger

### networkApplicationProperties

protected NetworkApplicationProperties networkApplicationProperties

### networkApplicationInformation

protected NetworkApplicationInformation networkApplicationInformation

### ftpApplicationProperties

protected FTPApplicationProperties ftpApplicationProperties

### ftpRemoteHostInformation

protected FTPRemoteHostInformation ftpRemoteHostInformation

### currentRemoteQueryInformationModel

protected QueryInformationModel currentRemoteQueryInformationModel

### currentRemoteQueryTreeBrowser

protected QueryTreeBrowser currentRemoteQueryTreeBrowser

### currentRemoteQuerySelectionQueryTreeRecord

protected QueryTreeRecord currentRemoteQuerySelectionQueryTreeRecord

### currentRemoteQuerySelectionUniqueKeys

protected AttributeList currentRemoteQuerySelectionUniqueKeys

### currentRemoteQuerySelectionUniqueKey

protected Attribute currentRemoteQuerySelectionUniqueKey

### currentRemoteQuerySelectionRetrieveAE

protected String currentRemoteQuerySelectionRetrieveAE

### currentRemoteQuerySelectionLevel

protected String currentRemoteQuerySelectionLevel

### ourCalledAETitle

protected String ourCalledAETitle

### savedImagesFolder

protected File savedImagesFolder

### storageSOPClassSCPDispatcher

protected StorageSOPClassSCPDispatcher storageSOPClassSCPDispatcher

### currentDatabaseTreeRecordSelections

protected DatabaseTreeRecord[] currentDatabaseTreeRecordSelections

### exportDirectoryPath

protected String exportDirectoryPath

### importDirectoryPath

protected String importDirectoryPath

## Constructor Details

### DownloadOrTransmit

public DownloadOrTransmit(String title) throws DicomException, IOException

Throws:
  `DicomException`
  `IOException`

## Method Details

### setCurrentRemoteQueryInformationModel

protected void setCurrentRemoteQueryInformationModel(String remoteAEForQuery)

### importFileIntoDatabase

protected static void importFileIntoDatabase(DatabaseInformationModel database, String dicomFileName, String fileRefererenceType) throws FileNotFoundException, IOException, DicomException

Throws:
  `FileNotFoundException`
  `IOException`
  `DicomException`

### activateStorageSCP

protected void activateStorageSCP() throws DicomException, IOException

Start DICOM storage listener for populating source database.

Throws:
  `DicomException`
  `IOException`

### activateTemporaryDatabases

protected void activateTemporaryDatabases() throws DicomException

Start local database.

Will not persist when the application is closed, so in memory database is used and instances live in the temporary filesystem.

Throws:
  `DicomException`

### getCurrentSourceFilePathSelections

protected Vector getCurrentSourceFilePathSelections()

### purgeFilesAndDatabaseInformation

protected void purgeFilesAndDatabaseInformation(DatabaseTreeRecord[] databaseSelections, MessageLogger logger, SafeProgressBarUpdaterThread progressBarUpdater, int done, int maximum) throws DicomException, IOException

Throws:
  `DicomException`
  `IOException`

### purgeFilesAndDatabaseInformation

protected void purgeFilesAndDatabaseInformation(DatabaseTreeRecord databaseSelection, MessageLogger logger, SafeProgressBarUpdaterThread progressBarUpdater, int done, int maximum) throws DicomException, IOException

Throws:
  `DicomException`
  `IOException`

### getSRDescriptionForLog

protected static String getSRDescriptionForLog(AttributeList list)

### makeNewFullyQualifiedInterchangeMediaInstancePathName

protected static String makeNewFullyQualifiedInterchangeMediaInstancePathName(int fileCount) throws IOException

Throws:
  `IOException`

### makeNewFullyQualifiedHierarchicalInstancePathName

protected static String makeNewFullyQualifiedHierarchicalInstancePathName(String sourceFileName) throws DicomException, IOException

Throws:
  `DicomException`
  `IOException`

### exportFiles

protected static void exportFiles(Vector<String> filesToCopy, File whereToCopyFiles, String actionNoun, SafeProgressBarUpdaterThread progressBarUpdater, MessageLogger logger, boolean detailedLog, boolean addDicomDirectory, boolean hierarchicalExport, String zipFileName)

### getQueryRetrieveAEFromIdentifier

public static String getQueryRetrieveAEFromIdentifier(AttributeList identifier, QueryInformationModel queryInformationModel)

### getQueryRetrieveLevel

public static String getQueryRetrieveLevel(AttributeList identifier, Attribute uniqueKey)

### setCurrentRemoteQuerySelection

protected void setCurrentRemoteQuerySelection(AttributeList uniqueKeys, Attribute uniqueKey, AttributeList identifier)

### performRetrieve

protected void performRetrieve(AttributeList uniqueKeys, String selectionLevel, String retrieveAE)

### main

public static void main(String[] arg)

The method to invoke the application.

Parameters:
  `arg` - none